package xerror

import "gitlab.wanzhuangkj.com/tush/xpkg/xerrors/xcode"

// Code 获取错误码。
// 如果没有错误代码，则返回 `xcode.CodeDefault`。
func (err *Error) Code() int {
	if err == nil {
		return xcode.CodeDefault
	}
	if err.code == xcode.CodeDefault {
		return Code(err.Unwrap())
	}
	return err.code
}

// SetCode 使用指定 `code` 更新内部 `code` 。
func (err *Error) SetCode(code int) {
	if err == nil {
		return
	}
	err.code = code
}
