package xset

import (
	"gitlab.wanzhuangkj.com/tush/xpkg/xtype"
)

type Set[T xtype.Key] struct {
	m map[any]bool
}

func NewSet[T xtype.Key]() *Set[T] {
	return &Set[T]{m: make(map[any]bool)}
}

func (s *Set[T]) Add(item any) {
	if !s.Exists(item) {
		s.m[item] = true
	}
}

func (s *Set[T]) Remove(item any) {
	delete(s.m, item)
}

func (s *Set[T]) Clear() {
	s.m = make(map[any]bool)
}

func (s *Set[T]) Exists(item any) bool {
	_, exists := s.m[item]
	return exists
}

func (s *Set[T]) Size() int {
	return len(s.m)
}

func (s *Set[T]) ToList() []T {
	var list []T
	for k := range s.m {
		if v, ok := k.(T); ok {
			list = append(list, v)
		}
	}
	return list
}
